#ifndef __HOISTING_H__
#define __HOISTING_H__
#include "LoopDetection.h"
#include "LoopStrengthReduction.h"
#include "Unit.h"
#include <list>
#include <memory>
#include <unordered_set>
#include <vector>

class Hoisting {
    std::unordered_set<SymbolEntry *> defInLoop;
    std::vector<std::pair<BasicBlock *, Instruction *>> invariant;
    LoopDetection *detector;
    BasicBlock *entry = nullptr;
    int areaCount;
    bool checkPhiControl(blockSet *loop, PhiInstruction *phi, BasicBlock *outbb,
                         BasicBlock *bb);
    void findInvariantLoop(blockSet *loop);
    void moveInvariantLoop(BasicBlock *bb, BasicBlock *outbb);
    void findInvariants(blockSet *);
    void findDef(blockSet *);
    void buildPrehead();
    void appendTo();
    void moveInvariantsOut(blockSet *);
    bool definedOut();
    bool definedIn_invariant();
    bool FunctionCheck(CallInstruction *call);
    bool invariantFind(int insttype);
    bool invariantNestCheck();
    BasicBlock *buildBB();
    bool rapidMove(blockSet *loop);
    Unit *unit;
    bool aggressive = 0;

  public:
    Hoisting(Unit *unit) : unit(unit) {}
    void execute(bool b);
};

#endif