#ifndef SYSYC_INSTRUCTIONSSCHEDULE_H
#define SYSYC_INSTRUCTIONSSCHEDULE_H

#include "MachineCode.h"


class InstructionsScheduling {
private:
    MachineUnit* mUnit;
    struct Node {
        MachineInstruction* inst;
        int delay;
        int priority;
        int degree;
        std::vector<int> pred;
        std::vector<std::pair<int, int>> succ; //(succ_inst, delay);
        Node();
        Node(MachineInstruction *i){
            inst = i;
            delay = 0;
            priority = -1;
            degree = 0;
        };
    };
    std::vector<Node*> Nodelist;
    

public:
    InstructionsScheduling(MachineUnit* mUnit) {
        this->mUnit = mUnit;
    }
    void pass();
    int getInstDelay(MachineInstruction* inst);
    void calculate_priority(int index);
    int getIndex(Node* node) {
        for(int i = 0; i < Nodelist.size(); i++) {
            if(Nodelist[i] == node) {
                return i;
            }
        }
        return -1;
    };

};


#endif 