#ifndef __LOOPSTRENTHREDUCTION_H__
#define __LOOPSTRENTHREDUCTION_H__
#include "BlockMerge.h"
#include "LoopDetection.h"
#include "Unit.h"
#include <list>
#include <memory>
#include <unordered_set>
#include <vector>

class LoopStrengthReduction {
    std::unordered_set<SymbolEntry *> defInLoop;
    std::unordered_set<SymbolEntry *> useInLoop;
    std::set<Instruction *> LoopExpression;
    std::set<Instruction *> OldInstrs;
    LoopDetection *detector;
    Operand *loopController;
    SymbolEntry *loopController_se;
    Instruction *loopControlInst_phi;
    void updateBlock_var(int opcode, BasicBlock *bb, int start, int step,
                         Operand *end);
    void updateBlock_ari(int opcode, BasicBlock *bb, int start, int step,
                         Operand *end);
    std::vector<std::pair<Instruction *, std::pair<Operand *, Operand *>>>
        AccumInstEleVec;
    Instruction *AccumInst;
    Instruction *AccumInst_phi;
    Operand *AccumEle;
    bool stop = false;

    void mulAddDiv(Instruction *mul, BasicBlock *bb);
    void getAllDefUse(BasicBlock *bb);
    BinaryInstruction *binCheck(BinaryInstruction *bin);
    void loopAccumulate2Mul(blockSet *loop);
    void findExpression(BasicBlock *bb);
    int getCmpInfo(unsigned opcode, double start, double step, double end,
                   double &finalValue);
    void eliUselessInsts(BasicBlock *bb);
    bool isSelfBinConst(BinaryInstruction *inst);
    bool isSelfBin(BinaryInstruction *inst);
    void updateBlock(BasicBlock *bb, int times, int finalValue);
    bool isDefInLoop(SymbolEntry *op);
    void arithmetic2Mul(blockSet *loop);
    Unit *unit;
    bool complete_flatten = 0;

  public:
    bool getCf() { return complete_flatten; }
    LoopStrengthReduction(Unit *unit) : unit(unit) {}
    void execute(bool aggressive);
    void execute2();
};
Instruction *findinst(int insttype, BasicBlock *bb);

#endif