#ifndef __MULTITHREAD_H__
#define __MULTITHREAD_H__

#include <unordered_map>
#include <vector>
#include <cmath>
#include "MachineCode.h"
#include "Function.h"
#include "LoopDetection.h"
#include "Vectorization.h"

class Multithread
{
public:
    Multithread(Unit* unit, MachineUnit* mUnit){this->unit = unit; this->mUnit = mUnit;}
    void pass();
    // 用于对多线程的指定寄存器进行维护
    void pass2();
    // void checkLoop(Function* func);
    void checkFunc(Function *func);
    bool checkFunc3(Function *func, bool call_multithread = false);
    // void doMultithread(loop_item* oneloop, Function* func);
    void doMultithread(std::vector<BasicBlock*> blks, Function *func);
    void doMultithread2(Function* func, BasicBlock* bodybb, std::vector<GepInstruction*> geps_inbodybb, 
        BasicBlock* iter22, std::vector<GepInstruction*> geps_initer22, BasicBlock* cond11, BasicBlock* iter12);
private:
    //int phiCount;
    Unit* unit;
    MachineUnit* mUnit;
    BasicBlock* condbb = nullptr;
    BasicBlock* bodybb = nullptr;
    BasicBlock* endbb = nullptr;
    LoopDetection* detector = nullptr;
    std::vector<BasicBlock*> blk_needmodify;
    std::vector<int> blk_needmodify_label;
    int multithread_who = 0;// 0~no one, 1~multithread1, 2~multithread2
};

// Instruction* find_inst(int insttype, BasicBlock* bb);
bool checkFunc2(Function *func);
#endif