#include "AccumExpReduction.h"

#define DEBUG_SWITCH_aer 0
#if DEBUG_SWITCH_aer
#define print(str) std::cout << str << "\n";
#else
#define print(str) //
#endif

#define MINIMUM_TIMES 1
#define MINIMUM_PARAMS 2
#define EXPLENGH 100
bool hasStore = 0;

using namespace std;

void AccumExpReduction::execute() {
    print("============ start AccumExpReduction ============");
    for (auto func : unit->get_functions()) {
        // if(dynamic_cast<IdentifierSymbolEntry *>(func->getSymPtr())->toStr()=="@main")continue;
        // std::cout
        //     << " == "
        //     << dynamic_cast<IdentifierSymbolEntry *>(func->getSymPtr())->toStr()
        //     << "\n";
        if (dynamic_cast<FunctionType *>(
                dynamic_cast<IdentifierSymbolEntry *>(func->getSymPtr())
                    ->getType())
                ->getParamSum() >= MINIMUM_PARAMS) {
            findExp(func);
        } else {
            print("continAdd");
            continAdd(func);
        }
    }
    print("============ end AccumExpReduction ============");
}

void AccumExpReduction::continAdd(Function *func) {
    print("============ start continAdd ============");
    for (auto bb : func->getBlockList()) {
        int count = 0;
        expInsts.clear();
        Operand *load_def = nullptr;
        Operand *accum = nullptr;
        bool start = 0;
        for (auto instr = bb->begin(); instr != bb->end();
             instr = instr->getNext()) {
            print(instr->getInstName());
            if (instr->isBin() &&
                dynamic_cast<BinaryInstruction *>(instr)->getOpcode() ==
                    BinaryInstruction::ADD &&
                instr->getDef()->getType()->isInt()) {
                expInsts.push_back(instr);
                print("count = " << count);
                auto binary = dynamic_cast<BinaryInstruction *>(instr);
                // auto opcode = binary->getOpcode();
                // if (!(opcode == BinaryInstruction::ADD
                //       // || opcode == BinaryInstruction::SUB
                //       )) {
                //     break;
                // }
                if (!start) {
                    count++;
                    start = 1;
                    accum = binary->getDef();
                    init = binary->getUse()[0];
                    load_def = binary->getUse()[1];
                    continue;
                } else {
                    if (load_def == binary->getUse()[1] &&
                        accum == binary->getUse()[0]) {
                        count++;
                        accum = binary->getDef();
                        continue;
                    }
                }
            }
            print("end exp");
            if (start) {
                if (count < EXPLENGH)
                    break;
                print("strat create exp.");
                end = accum;

                // 开始重构表达式
                vector<Instruction *> new_insts;
                auto tmp_bb = new BasicBlock(bb->getParent());

                // 累加次数
                auto dst = new Operand(new TemporarySymbolEntry(
                    TypeSystem::intType, SymbolTable::getLabel()));
                if (init == load_def) {
                    count++;
                    init = new Operand(
                        new ConstantSymbolEntry(TypeSystem::intType, 0));
                }
                auto times_op = new Operand(
                    new ConstantSymbolEntry(TypeSystem::intType, count));
                auto mul = new BinaryInstruction(BinaryInstruction::MUL, dst,
                                                 load_def, times_op, tmp_bb);
                new_insts.push_back(mul);

                auto add = new BinaryInstruction(BinaryInstruction::ADD, end,
                                                 init, dst, tmp_bb);
                new_insts.push_back(add);

                // 善后
                for (auto instr : new_insts) {
                    bb->insertBefore(instr, expInsts[0]);
                }
                for (auto instr : expInsts) {
                    bb->remove(instr);
                }
                expInsts.clear();
                new_insts.clear();
                bb->getParent()->remove(tmp_bb);
                std::cout << "yes addreduce done.\n";
                break;
            }
        }
    }
}

bool AccumExpReduction::isValid(Instruction *instr) {
    // Todo: 数组/函数调用
    if (instr->isCall() || instr->isRet() || instr->isFtos() ||
        instr->isStof() || instr->isBitcast() || instr->isGep()) {
        return false;
    }
    return true;
}

void AccumExpReduction::simplifyExp(int res, BasicBlock *bb) {
    print("===== simplifyExp =====");
    vector<Instruction *> new_insts;
    // Operand *Accum = init;
    auto tmp_bb = new BasicBlock(bb->getParent());
    if (res == 2) {
        int times = (*(expOps.begin())).second.second;
        int opcode = BinaryInstruction::ADD;
        if (times < 0)
            opcode = BinaryInstruction::SUB;

        // print("Accum = " << Accum->toStr());
        Operand *sum =
            new Operand(new ConstantSymbolEntry(TypeSystem::intType, 0));

        for (auto const &src : expOps) {
            // auto addr = dynamic_cast<IdentifierSymbolEntry
            // *>(src.first)->getAddr(); print(src.first->toStr());
            // print(addr->toStr());

            Operand *dst1;
            if (src.first->isConstant()) {
                dst1 = new Operand(src.first);
            } else {
                dst1 = new Operand(new TemporarySymbolEntry(
                    TypeSystem::intType, SymbolTable::getLabel()));
                Operand *addr = (src.second.first)->getUse()[0];
                auto load = new LoadInstruction(dst1, addr, tmp_bb);
                new_insts.push_back(load);
            }
            // print("dst1 = " << dst1->toStr());

            // Instruction *load = (src.second).first;
            auto dst2 = new Operand(new TemporarySymbolEntry(
                TypeSystem::intType, SymbolTable::getLabel()));
            auto bin = new BinaryInstruction(opcode, dst2, sum, dst1, tmp_bb);
            new_insts.push_back(bin);
            sum = dst2;
        }

        // 累加次数
        auto dst = new Operand(new TemporarySymbolEntry(
            TypeSystem::intType, SymbolTable::getLabel()));
        auto times_op =
            new Operand(new ConstantSymbolEntry(TypeSystem::intType, times));
        auto mul = new BinaryInstruction(BinaryInstruction::MUL, dst, sum,
                                         times_op, tmp_bb);

        print("times_op = " << times_op->toStr());
        new_insts.push_back(mul);

        // 加回原op
        Operand *load_dst;
        Instruction *add;
        if (hasStore) {
            load_dst = new Operand(new TemporarySymbolEntry(
                TypeSystem::intType, SymbolTable::getLabel()));
            auto load =
                new LoadInstruction(load_dst, init->getDef()->getDef(), tmp_bb);
            new_insts.push_back(load);
            add = new BinaryInstruction(BinaryInstruction::ADD, end, load_dst,
                                        dst, tmp_bb);
        } else {
            add = new BinaryInstruction(BinaryInstruction::ADD, end, init, dst,
                                        tmp_bb);
        }
        new_insts.push_back(add);

        // 存回值
        if (hasStore) {
            auto store = new StoreInstruction(init, end, tmp_bb);
            new_insts.push_back(store);
        }

        for (auto instr : new_insts) {
            bb->insertBefore(instr, expInsts[0]);
        }
        for (auto instr : expInsts) {
            bb->remove(instr);
        }
    }
    expInsts.clear();
    new_insts.clear();
    bb->getParent()->remove(tmp_bb);
    std::cout << "yes asr done.\n";
}

void AccumExpReduction::findExp(Function *func) {
    print("===== findExp =====");
    bool load_switch = 0;
    bool start = 0;
    Operand *accum = nullptr;
    Operand *load_def = nullptr;
    Operand *store_def = nullptr;
    int count = 0;
    for (auto bb : func->getBlockList()) {
        print("==== bb" << bb->getNo() << " ====");
        init = nullptr;
        end = nullptr;
        expOps.clear();
        expInsts.clear();
        count = 0;
        start = 0;
        hasStore = 0;
        accum = nullptr;
        load_def = nullptr;
        for (auto instr = bb->begin(); instr != bb->end();
             instr = instr->getNext()) {
            if (!(isValid(instr)))
                break;
            if (
                // start &&
                instr->isStore()) {
                hasStore = true;
                if (start) {
                    store_def = instr->getDef();
                    expInsts.push_back(instr);
                }
                continue; // Fix 可能有问题
            }
            if (instr->getDef()) {
                print(instr->getDef()->toStr()
                      << " " << instr->getInstName() << " start = " << start);
            }
            // print(instr->getInstName());
            // if (!isValid(instr))
            //     break;
            if (!start && instr->isLoad()) {
                start = 1;
                load_switch = 1;
                load_def = instr->getDef();
                expInsts.push_back(instr);
            } else if (start) {
                count++;
                if (hasStore) {
                    print("in hasStore");
                    if (load_switch && instr->isBin() &&
                        instr->getDef()->getType()->isInt()) {
                        print("  in hasStore : bin");
                        auto binary = dynamic_cast<BinaryInstruction *>(instr);
                        auto opcode = binary->getOpcode();
                        if (opcode == BinaryInstruction::ADD ||
                            opcode == BinaryInstruction::SUB) {
                            bool link = 0;
                            Operand *src = nullptr;
                            for (auto use : instr->getUse()) {
                                // print("use = " << use->toStr());

                                if (load_def == use)
                                    link = 1;
                                else
                                    src = use;
                            }
                            if (init == nullptr && store_def != nullptr)
                                init = store_def;
                            // if (!(load_def->getUse()[0] ==
                            // store_def->getDef()))
                            //     link = 0;
                            if (link) {

                                SymbolEntry *se = src->getSymbolEntry();
                                // 常量-se映射
                                if (se->isConstant()) {
                                    auto se_constant =
                                        dynamic_cast<ConstantSymbolEntry *>(
                                            src->getSymbolEntry());
                                    if (numberOp_map.find(
                                            se_constant->getValue()) ==
                                        numberOp_map.end()) {
                                        numberOp_map[se_constant->getValue()] =
                                            se;
                                    } else {
                                        se = numberOp_map[se_constant
                                                              ->getValue()];
                                    }
                                }
                                // 更新表达式src记录
                                if (expOps.find(se) == expOps.end()) {
                                    print("  store new "
                                          << src->getSymbolEntry()->toStr());
                                    expOps[se] =
                                        std::make_pair(load_def->getDef(),
                                                       getOperator(opcode));

                                } else {
                                    print("store add "
                                          << src->getSymbolEntry()->toStr());
                                    expOps[se].second += getOperator(opcode);
                                }
                                load_switch = 0;
                                accum = instr->getDef();
                                expInsts.push_back(instr);
                                continue;
                            }
                        } else {
                            init = nullptr;
                            end = nullptr;
                            expOps.clear();
                            expInsts.clear();
                            start = 0;
                            hasStore = 0;
                            count = 0;
                            accum = nullptr;
                            load_def = nullptr;
                            continue;
                        }
                    } else if (!load_switch && instr->isLoad()) {
                        // print("!load_switch && instr->isLoad()");
                        if (instr->getUse()[0] == store_def) {
                            load_switch = 1;
                            load_def = instr->getDef();
                            expInsts.push_back(instr);
                        }
                        continue;
                    }
                    // 处理mem2reg没处理的参数左值情况，会有store
                    if (count > EXPLENGH && hasStore && instr->isLoad()) {
                        print("hasStore end count = " << count);
                        if (instr->getPrev()->getPrev()->isStore()) {
                            expInsts.pop_back();
                            // expInsts.pop_back();
                            print("store_def = " << store_def->toStr());
                            print("accum = " << accum->toStr());
                            end = accum;
                            int res = rvalCheck();
                            if (res) {
                                simplifyExp(res, bb);
                            }
                        }
                    }
                    print("out hasStore");
                } else {
                    if (load_switch && instr->isBin() &&
                        instr->getDef()->getType()->isInt()) {
                        auto binary = dynamic_cast<BinaryInstruction *>(instr);
                        auto opcode = binary->getOpcode();
                        if (opcode == BinaryInstruction::ADD ||
                            opcode == BinaryInstruction::SUB) {
                            bool link = 0;
                            for (auto use : instr->getUse()) {
                                if (load_def == use)
                                    link = 1;
                            }
                            if (link) {
                                if (init == nullptr) {
                                    for (auto use : instr->getUse()) {
                                        if (load_def != use)
                                            init = use;
                                    }
                                }

                                // print("load addr =
                                // "<<load_def->getDef()->getUse()[0]->getSymbolEntry()->toStr());
                                if (expOps.find(load_def->getDef()
                                                    ->getUse()[0]
                                                    ->getSymbolEntry()) ==
                                    expOps.end()) {
                                    // print("LOAD use
                                    // ="<<load_def->getDef()->getUse()[0]->toStr());
                                    expOps[load_def->getDef()
                                               ->getUse()[0]
                                               ->getSymbolEntry()] =
                                        std::make_pair(load_def->getDef(),
                                                       getOperator(opcode));

                                } else {
                                    expOps[load_def->getDef()
                                               ->getUse()[0]
                                               ->getSymbolEntry()]
                                        .second += getOperator(opcode);
                                }
                                load_switch = 0;
                                accum = instr->getDef();
                                expInsts.push_back(instr);
                                continue;
                            }
                        }
                    } else if (!load_switch && instr->isLoad()) {
                        load_switch = 1;
                        load_def = instr->getDef();
                        expInsts.push_back(instr);
                        continue;
                    }
                    print("========EXP END=========");
                    if (count > EXPLENGH && instr->isBin()) { // 终了
                        bool link = 0;
                        for (auto use : instr->getUse()) {
                            if (accum == use) {
                                end = use;
                                link = 1;
                            }
                        }
                        if (!link) {
                            init = nullptr;
                            end = nullptr;
                            expOps.clear();
                            expInsts.clear();
                            start = 0;
                            hasStore = 0;
                            count = 0;
                            accum = nullptr;
                            load_def = nullptr;
                            continue;
                        }
                        int res = rvalCheck();
                        if (res) {
                            simplifyExp(res, bb);
                        }
                    }
                }

                init = nullptr;
                end = nullptr;
                expOps.clear();
                expInsts.clear();
                start = 0;
                count = 0;
                hasStore = 0;
                accum = nullptr;
                load_def = nullptr;
            }
        }
    }
}

// Todo: 条件其实可以放宽
int AccumExpReduction::rvalCheck() {
    print("== rvalCheck ==");

    bool sameTimes = true;
    int times = (*(expOps.begin())).second.second;
    for (auto const &src : expOps) {
        print((src.first)->toStr() << " " << (src.second).second);
        if ((src.second).second <= MINIMUM_TIMES)
            return 0;
        if ((src.second).second != times)
            sameTimes = false;
    }
    print("sameTimes = " << sameTimes);
    if (sameTimes) {
        return 2;

    } else {
        return 1;
    }
}

int AccumExpReduction::getOperator(int opcode) {
    switch (opcode) {
    case BinaryInstruction::SUB:
        return -1;
        break;
    case BinaryInstruction::ADD:
        return 1;
        break;
    default:
        assert(0);
        break;
    }
}