/* A Bison parser, made by GNU Bison 3.5.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* "%code top" blocks.  */
#line 1 "src/parser.y"

    #include <cstring>
    #include <stack>
    #include <vector>
    #include <iostream>
    #include <assert.h>
    #include <algorithm>
    #include "parser.h"
    extern int yylineno;
    extern char* yytext;
    extern Ast ast;
    extern bool *fcheck;

    #define DEBUG_SWITCH_TYPE_CHECK 1
    #if DEBUG_SWITCH_TYPE_CHECK
    #define printTyCk(str) std::cerr<<"[error]:"<<str<<"\n";
    #else
    #define printTyCk(str) //
    #endif

    int yylex();
    int yyerror(char const*);
    Type* CurType;
    Type* ReturnType;
    bool isConst;
    ArrayType* curArrayType;
    int idx;
    double* arrayValue;
    std::vector<InitValueListExpr*> InitValuesVec;
    std::vector<StmtNode*> WhileNodesVec;
    InitValueListExpr* top;
    int leftCnt = 0;
    int WhileIndex = 0;
    int AllParamNum = 0;
    int IntParamNum = 0;
    int FloatParamNum = 0;
    int NoZeroNum = 0;

#line 106 "src/parser.cpp"




# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_INCLUDE_PARSER_H_INCLUDED
# define YY_YY_INCLUDE_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif
/* "%code requires" blocks.  */
#line 40 "src/parser.y"

    #include "SymbolTable.h"
    #include "Ast.h"
    #include "Type.h"

#line 158 "src/parser.cpp"

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DECIMIAL = 258,
    OCTAL = 259,
    HEXADECIMAL = 260,
    DECIMAL_FLOAT = 261,
    HEXADECIMAL_FLOAT = 262,
    ID = 263,
    SYSY_FUNC_NOPARAM = 264,
    SYSY_FUNC_WITHPARAM = 265,
    INT = 266,
    VOID = 267,
    FLOAT = 268,
    IF = 269,
    ELSE = 270,
    WHILE = 271,
    CONST = 272,
    OR = 273,
    AND = 274,
    ADD = 275,
    SUB = 276,
    MUL = 277,
    DIV = 278,
    MOD = 279,
    LESSEQUAL = 280,
    GREATER = 281,
    GREATEREQUAL = 282,
    LESS = 283,
    EQUAL = 284,
    NOTEQUAL = 285,
    NOT = 286,
    ASSIGN = 287,
    COMMA = 288,
    SEMICOLON = 289,
    LPAREN = 290,
    RPAREN = 291,
    LBRACE = 292,
    RBRACE = 293,
    LBRACKET = 294,
    RBRACKET = 295,
    RETURN = 296,
    CONTINUE = 297,
    BREAK = 298,
    THEN = 299
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 46 "src/parser.y"

    char* StrType;
    int IntType;
    float FloatType;
    StmtNode* StateType;
    ExprNode* ExprType;
    Type* type;
    SymbolEntry* se;

#line 224 "src/parser.cpp"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_INCLUDE_PARSER_H_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  70
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   293

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  45
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  43
/* YYNRULES -- Number of rules.  */
#define YYNRULES  106
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  173

#define YYUNDEFTOK  2
#define YYMAXUTOK   299


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    85,    85,    90,    95,   100,   105,   105,   114,   119,
     122,   127,   127,   142,   151,   160,   163,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   186,   187,
     192,   200,   208,   216,   226,   229,   243,   247,   251,   255,
     260,   268,   269,   277,   285,   292,   299,   302,   313,   325,
     326,   361,   391,   414,   415,   438,   463,   466,   478,   490,
     502,   516,   517,   529,   543,   544,   558,   559,   573,   577,
     581,   584,   592,   593,   597,   606,   610,   614,   622,   630,
     638,   657,   676,   695,   720,   720,   762,   774,   777,   780,
     786,   841,   863,   863,   900,   903,   910,   918,   910,   947,
     948,   953,   954,   956,   960,   965,   989
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DECIMIAL", "OCTAL", "HEXADECIMAL",
  "DECIMAL_FLOAT", "HEXADECIMAL_FLOAT", "ID", "SYSY_FUNC_NOPARAM",
  "SYSY_FUNC_WITHPARAM", "INT", "VOID", "FLOAT", "IF", "ELSE", "WHILE",
  "CONST", "OR", "AND", "ADD", "SUB", "MUL", "DIV", "MOD", "LESSEQUAL",
  "GREATER", "GREATEREQUAL", "LESS", "EQUAL", "NOTEQUAL", "NOT", "ASSIGN",
  "COMMA", "SEMICOLON", "LPAREN", "RPAREN", "LBRACE", "RBRACE", "LBRACKET",
  "RBRACKET", "RETURN", "CONTINUE", "BREAK", "THEN", "$accept", "Program",
  "AssignState", "ExprState", "BlankState", "BlockState", "$@1", "IfState",
  "WhileState", "@2", "BreakState", "ContinueState", "ReturnState",
  "State", "States", "LVal", "PrimaryExpr", "UnaryExpr", "MulExpr",
  "AddExpr", "RelExpr", "EqExpr", "LAndExpr", "LOrExpr", "Cond", "Type",
  "DeclState", "VarDeclState", "VarDeclList", "VarDecl", "@3",
  "ConstVarDeclState", "ArrayIndices", "InitArrList", "@4", "InitArr",
  "FuncDecl", "$@5", "@6", "FuncRParams", "FuncFParamsList", "FuncFParams",
  "FuncFParam", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299
};
# endif

#define YYPACT_NINF (-113)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-97)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     197,  -113,  -113,  -113,  -113,  -113,    -9,   -29,   -10,  -113,
    -113,  -113,    47,    74,    44,   258,   258,   258,  -113,   258,
      75,   250,    -2,    78,    28,  -113,  -113,  -113,  -113,  -113,
    -113,  -113,  -113,  -113,  -113,   197,    19,  -113,  -113,    66,
      -6,    34,    17,    96,    98,    84,    85,  -113,  -113,  -113,
    -113,   216,    13,    80,    86,   258,   258,   258,    88,  -113,
    -113,  -113,  -113,    87,  -113,   197,  -113,    90,  -113,  -113,
    -113,  -113,   258,   258,   258,   258,   258,   258,   258,   258,
     258,   258,   258,   258,   258,   258,  -113,    -8,    89,    94,
      30,  -113,  -113,  -113,    16,  -113,    91,   258,  -113,    36,
      92,    99,   -28,    37,  -113,   156,  -113,    93,  -113,  -113,
    -113,    66,    66,    -6,    -6,    -6,    -6,    34,    34,    17,
      96,    71,    -3,    95,    71,    71,    88,  -113,   258,  -113,
    -113,   100,  -113,   197,  -113,  -113,  -113,  -113,    82,  -113,
    -113,  -113,    44,  -113,  -113,  -113,  -113,  -113,   117,   197,
    -113,    71,    71,   126,   103,   108,  -113,   197,  -113,  -113,
      12,  -113,    97,  -113,    44,  -113,    71,  -113,    80,   105,
    -113,  -113,  -113
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,    36,    37,    38,    39,    40,    30,    31,    32,    69,
      70,    71,     0,     0,     0,     0,     0,     0,     5,     0,
       6,     0,     0,     0,     0,    17,    19,    18,    20,    21,
      22,    24,    23,    27,    28,     2,    35,    41,    49,    53,
      56,    61,    64,    66,    68,     0,     0,    26,    72,    73,
      25,     0,     0,    33,     0,     0,     0,     0,     0,    35,
      46,    47,    48,     0,     8,     0,    15,     0,    14,    13,
       1,    29,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     4,    77,    78,    79,
       0,    76,    45,    99,     0,    87,     0,     0,    42,     0,
       0,     0,    77,     0,    34,     0,    16,     0,    50,    51,
      52,    54,    55,    58,    59,    60,    57,    62,    63,    65,
      67,     0,    83,     0,     0,     0,     0,    74,     0,    44,
      88,     0,    43,     0,    11,    86,     7,     3,    92,    90,
      80,    84,   102,    81,    82,    75,   100,    89,     9,     0,
      91,     0,     0,     0,     0,   101,   104,     0,    12,    94,
       0,    85,   105,    97,     0,    10,     0,    93,   106,     0,
     103,    95,    98
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
    -113,  -113,  -113,  -113,  -113,   -26,  -113,  -113,  -113,  -113,
    -113,  -113,  -113,   -32,    79,     0,  -113,    -7,    23,     6,
      21,    61,    62,  -113,   -14,   -13,  -113,  -113,   113,    20,
    -113,  -113,    -4,  -112,  -113,  -113,  -113,  -113,  -113,   101,
    -113,  -113,   -16
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    24,    25,    26,    27,    28,    65,    29,    30,   149,
      31,    32,    33,    34,    35,    59,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    90,    91,
     152,    49,   122,   140,   151,   160,    50,   123,   169,    94,
     154,   155,   156
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,    58,    53,    71,   121,    63,    54,    67,    60,    61,
      62,    52,   143,   144,    76,    77,     1,     2,     3,     4,
       5,     6,     7,     8,   121,    55,    51,   -96,    70,   141,
      52,    52,    68,    15,    16,    36,    97,    93,    96,   159,
     161,    93,   100,   101,    17,   166,    82,    83,    19,   128,
     167,    72,   129,    95,   171,     9,    10,    11,   107,    78,
      79,    80,    81,   126,   127,    36,   108,   109,   110,   128,
     126,   135,   132,    71,     1,     2,     3,     4,     5,     6,
       7,     8,    56,   131,   113,   114,   115,   116,    73,    74,
      75,    15,    16,    87,    88,    89,   102,    88,    89,   111,
     112,   148,    17,   117,   118,    36,    19,   139,   138,    57,
     139,   139,    69,    64,   146,    84,    85,   158,    86,    97,
     150,   124,    98,   104,   106,   165,   125,   137,   133,   153,
     142,   130,   157,    36,   162,   134,    52,   139,   139,   163,
     147,   164,    20,   172,   105,   119,   145,   120,   170,    36,
       0,   153,   139,     0,     0,     0,    99,    36,   168,     1,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,   103,    13,    14,     0,     0,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    17,     0,     0,
      18,    19,     0,    20,   136,     0,     0,    21,    22,    23,
       1,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,     0,    13,    14,     0,     0,    15,    16,     1,
       2,     3,     4,     5,     6,     7,     8,     0,    17,     0,
       0,    18,    19,     0,    20,     0,    15,    16,    21,    22,
      23,     0,     0,     0,     0,     0,     0,    17,     0,     0,
       0,    19,    92,     1,     2,     3,     4,     5,     6,     7,
       8,     1,     2,     3,     4,     5,     6,     7,     8,     0,
      15,    16,     0,     0,     0,     0,     0,     0,    15,    16,
       0,    17,     0,     0,    66,    19,     0,     0,     0,    17,
       0,     0,     0,    19
};

static const yytype_int16 yycheck[] =
{
       0,    14,     6,    35,    32,    19,    35,    21,    15,    16,
      17,    39,   124,   125,    20,    21,     3,     4,     5,     6,
       7,     8,     9,    10,    32,    35,    35,    35,     0,    32,
      39,    39,    34,    20,    21,    35,    39,    51,    52,   151,
     152,    55,    56,    57,    31,    33,    29,    30,    35,    33,
      38,    32,    36,    40,   166,    11,    12,    13,    72,    25,
      26,    27,    28,    33,    34,    65,    73,    74,    75,    33,
      33,    34,    36,   105,     3,     4,     5,     6,     7,     8,
       9,    10,    35,    97,    78,    79,    80,    81,    22,    23,
      24,    20,    21,     8,     9,    10,     8,     9,    10,    76,
      77,   133,    31,    82,    83,   105,    35,   121,    37,    35,
     124,   125,    34,    38,   128,    19,    18,   149,    34,    39,
      38,    32,    36,    36,    34,   157,    32,    34,    36,   142,
      35,    40,    15,   133,     8,    36,    39,   151,   152,    36,
      40,    33,    37,   169,    65,    84,   126,    85,   164,   149,
      -1,   164,   166,    -1,    -1,    -1,    55,   157,   162,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    58,    16,    17,    -1,    -1,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    -1,    41,    42,    43,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    16,    17,    -1,    -1,    20,    21,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    31,    -1,
      -1,    34,    35,    -1,    37,    -1,    20,    21,    41,    42,
      43,    -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,
      -1,    35,    36,     3,     4,     5,     6,     7,     8,     9,
      10,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      -1,    31,    -1,    -1,    34,    35,    -1,    -1,    -1,    31,
      -1,    -1,    -1,    35
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    16,    17,    20,    21,    31,    34,    35,
      37,    41,    42,    43,    46,    47,    48,    49,    50,    52,
      53,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    76,
      81,    35,    39,    77,    35,    35,    35,    35,    70,    60,
      62,    62,    62,    69,    38,    51,    34,    69,    34,    34,
       0,    58,    32,    22,    23,    24,    20,    21,    25,    26,
      27,    28,    29,    30,    19,    18,    34,     8,     9,    10,
      73,    74,    36,    69,    84,    40,    69,    39,    36,    84,
      69,    69,     8,    73,    36,    59,    34,    69,    62,    62,
      62,    63,    63,    64,    64,    64,    64,    65,    65,    66,
      67,    32,    77,    82,    32,    32,    33,    34,    33,    36,
      40,    69,    36,    36,    36,    34,    38,    34,    37,    69,
      78,    32,    35,    78,    78,    74,    69,    40,    58,    54,
      38,    79,    75,    70,    85,    86,    87,    15,    58,    78,
      80,    78,     8,    36,    33,    58,    33,    38,    77,    83,
      87,    78,    50
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    45,    46,    47,    48,    49,    51,    50,    50,    52,
      52,    54,    53,    55,    56,    57,    57,    58,    58,    58,
      58,    58,    58,    58,    58,    58,    58,    58,    59,    59,
      60,    60,    60,    60,    61,    61,    61,    61,    61,    61,
      61,    62,    62,    62,    62,    62,    62,    62,    62,    63,
      63,    63,    63,    64,    64,    64,    65,    65,    65,    65,
      65,    66,    66,    66,    67,    67,    68,    68,    69,    70,
      70,    70,    71,    71,    72,    73,    73,    74,    74,    74,
      74,    74,    74,    74,    75,    74,    76,    77,    77,    77,
      78,    78,    79,    78,    80,    80,    82,    83,    81,    84,
      84,    85,    85,    86,    86,    87,    87
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     4,     2,     1,     0,     4,     2,     5,
       7,     0,     6,     2,     2,     2,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     4,     4,     3,     2,     2,     2,     1,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       3,     1,     3,     3,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     1,     1,     1,
       3,     3,     3,     2,     0,     5,     4,     2,     3,     4,
       1,     2,     0,     4,     1,     3,     0,     0,     8,     1,
       3,     1,     0,     3,     1,     2,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[+yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[+*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 85 "src/parser.y"
             {
        ast.setRoot((yyvsp[0].StateType));
    }
#line 1556 "src/parser.cpp"
    break;

  case 3:
#line 90 "src/parser.y"
                                 {
        (yyval.StateType) = new AssignStmt((yyvsp[-3].ExprType), (yyvsp[-1].ExprType));
    }
#line 1564 "src/parser.cpp"
    break;

  case 4:
#line 95 "src/parser.y"
                     {
        (yyval.StateType) = new ExprStmt((yyvsp[-1].ExprType));
    }
#line 1572 "src/parser.cpp"
    break;

  case 5:
#line 100 "src/parser.y"
                {
        (yyval.StateType) = new BlankStmt();
    }
#line 1580 "src/parser.cpp"
    break;

  case 6:
#line 105 "src/parser.y"
             {
        identifiers = new SymbolTable(identifiers);
    }
#line 1588 "src/parser.cpp"
    break;

  case 7:
#line 108 "src/parser.y"
                    {
        (yyval.StateType) = new CompoundStmt((yyvsp[-1].StateType));
        SymbolTable* ScopeTable = identifiers;
        identifiers = identifiers->getPrev();
        delete ScopeTable;
    }
#line 1599 "src/parser.cpp"
    break;

  case 8:
#line 114 "src/parser.y"
                    {
        (yyval.StateType) = new CompoundStmt();
    }
#line 1607 "src/parser.cpp"
    break;

  case 9:
#line 119 "src/parser.y"
                                             {
        (yyval.StateType) = new IfStmt((yyvsp[-2].ExprType), (yyvsp[0].StateType));
    }
#line 1615 "src/parser.cpp"
    break;

  case 10:
#line 122 "src/parser.y"
                                             {
        (yyval.StateType) = new IfElseStmt((yyvsp[-4].ExprType), (yyvsp[-2].StateType), (yyvsp[0].StateType));
    }
#line 1623 "src/parser.cpp"
    break;

  case 11:
#line 127 "src/parser.y"
                               {
        WhileIndex++;
        WhileStmt *whileNode = new WhileStmt((yyvsp[-1].ExprType));
        (yyval.StateType) = whileNode;
        WhileNodesVec.push_back(whileNode);
    }
#line 1634 "src/parser.cpp"
    break;

  case 12:
#line 133 "src/parser.y"
          {
        WhileStmt *whileNode = dynamic_cast<WhileStmt*>((yyvsp[-1].StateType)); 
        whileNode->setStmt((yyvsp[0].StateType));
        (yyval.StateType)=whileNode;
        WhileNodesVec.pop_back();
        WhileIndex--;
    }
#line 1646 "src/parser.cpp"
    break;

  case 13:
#line 142 "src/parser.y"
                      {
        if(WhileIndex <= 0){
            printTyCk("Continue is not in while statement.");
            assert(0);
        }
        (yyval.StateType) = new BreakStmt(WhileNodesVec.back());
    }
#line 1658 "src/parser.cpp"
    break;

  case 14:
#line 151 "src/parser.y"
                         {
        if(WhileIndex <= 0){
            printTyCk("Break is not in while statement.")
            assert(0);
        }
        (yyval.StateType) = new ContinueStmt(WhileNodesVec.back());
    }
#line 1670 "src/parser.cpp"
    break;

  case 15:
#line 160 "src/parser.y"
                       {
        (yyval.StateType) = new ReturnStmt();
    }
#line 1678 "src/parser.cpp"
    break;

  case 16:
#line 163 "src/parser.y"
                            {
        if (((yyvsp[-1].ExprType)->getType()->isFloat() && ReturnType->isInt()) ||
            ((yyvsp[-1].ExprType)->getType()->isInt() && ReturnType->isFloat())) {
            (yyval.StateType) = new ReturnStmt(new ImplicitCastExpr((yyvsp[-1].ExprType), ReturnType));
        } else {
            (yyval.StateType) = new ReturnStmt((yyvsp[-1].ExprType));            
        }
    }
#line 1691 "src/parser.cpp"
    break;

  case 17:
#line 173 "src/parser.y"
                  {(yyval.StateType)=(yyvsp[0].StateType);}
#line 1697 "src/parser.cpp"
    break;

  case 18:
#line 174 "src/parser.y"
                 {(yyval.StateType) = (yyvsp[0].StateType);}
#line 1703 "src/parser.cpp"
    break;

  case 19:
#line 175 "src/parser.y"
                {(yyval.StateType) = (yyvsp[0].StateType);}
#line 1709 "src/parser.cpp"
    break;

  case 20:
#line 176 "src/parser.y"
                 {(yyval.StateType)=(yyvsp[0].StateType);}
#line 1715 "src/parser.cpp"
    break;

  case 21:
#line 177 "src/parser.y"
              {(yyval.StateType) = (yyvsp[0].StateType);}
#line 1721 "src/parser.cpp"
    break;

  case 22:
#line 178 "src/parser.y"
                 {(yyval.StateType) = (yyvsp[0].StateType);}
#line 1727 "src/parser.cpp"
    break;

  case 23:
#line 179 "src/parser.y"
                    {(yyval.StateType)=(yyvsp[0].StateType);}
#line 1733 "src/parser.cpp"
    break;

  case 24:
#line 180 "src/parser.y"
                 {(yyval.StateType)=(yyvsp[0].StateType);}
#line 1739 "src/parser.cpp"
    break;

  case 25:
#line 181 "src/parser.y"
               {(yyval.StateType) = (yyvsp[0].StateType);}
#line 1745 "src/parser.cpp"
    break;

  case 26:
#line 182 "src/parser.y"
                {(yyval.StateType) = (yyvsp[0].StateType);}
#line 1751 "src/parser.cpp"
    break;

  case 27:
#line 183 "src/parser.y"
                  {(yyval.StateType) = (yyvsp[0].StateType);}
#line 1757 "src/parser.cpp"
    break;

  case 28:
#line 186 "src/parser.y"
            {(yyval.StateType)=(yyvsp[0].StateType);}
#line 1763 "src/parser.cpp"
    break;

  case 29:
#line 187 "src/parser.y"
                  {
        (yyval.StateType) = new SeqNode((yyvsp[-1].StateType), (yyvsp[0].StateType));
    }
#line 1771 "src/parser.cpp"
    break;

  case 30:
#line 192 "src/parser.y"
         {
        SymbolEntry* se = identifiers->lookup((yyvsp[0].StrType));
        if(se == nullptr){
            printTyCk("identifier " << (char*)(yyvsp[0].StrType) << " is not defined.");
        }
        (yyval.ExprType) = new Id(se);
        delete [](yyvsp[0].StrType);
    }
#line 1784 "src/parser.cpp"
    break;

  case 31:
#line 200 "src/parser.y"
                        {
        SymbolEntry* se = identifiers->lookup((yyvsp[0].StrType));
        if(se == nullptr){
            printTyCk("identifier " << (char*)(yyvsp[0].StrType) << " is not defined.");
        }
        (yyval.ExprType) = new Id(se);
        delete [](yyvsp[0].StrType);
    }
#line 1797 "src/parser.cpp"
    break;

  case 32:
#line 208 "src/parser.y"
                          {
        SymbolEntry* se = identifiers->lookup((yyvsp[0].StrType));
        if(se == nullptr){
            printTyCk("identifier " << (char*)(yyvsp[0].StrType) << " is not defined.");
        }
        (yyval.ExprType) = new Id(se);
        delete [](yyvsp[0].StrType);
    }
#line 1810 "src/parser.cpp"
    break;

  case 33:
#line 216 "src/parser.y"
                     {
        SymbolEntry* se = identifiers->lookup((yyvsp[-1].StrType));
        if(se == nullptr){
            printTyCk("identifier "<< (char*)(yyvsp[-1].StrType) << " is not defined.");
        }
        (yyval.ExprType) = new Id(se, (yyvsp[0].ExprType));
        delete [](yyvsp[-1].StrType);
    }
#line 1823 "src/parser.cpp"
    break;

  case 34:
#line 226 "src/parser.y"
                         {
        (yyval.ExprType) = (yyvsp[-1].ExprType);
    }
#line 1831 "src/parser.cpp"
    break;

  case 35:
#line 229 "src/parser.y"
           {
        IdentifierSymbolEntry *id = dynamic_cast<IdentifierSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
        if(id->getConst()){
            if(id->getType()->isInt() || id->getType()->isFloat()){
                SymbolEntry *cs = new ConstantSymbolEntry(id->getType(), id->getValue());
                (yyval.ExprType) = new Constant(cs);
            }
            else{
                (yyval.ExprType) = (yyvsp[0].ExprType);
            }
        }else{
            (yyval.ExprType) = (yyvsp[0].ExprType);
        }
    }
#line 1850 "src/parser.cpp"
    break;

  case 36:
#line 243 "src/parser.y"
               {
        ConstantSymbolEntry *se = new ConstantSymbolEntry(TypeSystem::intType, (yyvsp[0].IntType));
        (yyval.ExprType) = new Constant(se);
    }
#line 1859 "src/parser.cpp"
    break;

  case 37:
#line 247 "src/parser.y"
            {
        ConstantSymbolEntry *se = new ConstantSymbolEntry(TypeSystem::intType, (yyvsp[0].IntType));
        (yyval.ExprType) = new Constant(se);
    }
#line 1868 "src/parser.cpp"
    break;

  case 38:
#line 251 "src/parser.y"
                  {
        ConstantSymbolEntry *se = new ConstantSymbolEntry(TypeSystem::intType, (yyvsp[0].IntType));
        (yyval.ExprType) = new Constant(se);
    }
#line 1877 "src/parser.cpp"
    break;

  case 39:
#line 255 "src/parser.y"
                    {
        *fcheck=1;
        ConstantSymbolEntry *se = new ConstantSymbolEntry(TypeSystem::floatType, (yyvsp[0].FloatType));
        (yyval.ExprType) = new Constant(se);
    }
#line 1887 "src/parser.cpp"
    break;

  case 40:
#line 260 "src/parser.y"
                        {
        *fcheck=1;
        ConstantSymbolEntry *se = new ConstantSymbolEntry(TypeSystem::floatType, (yyvsp[0].FloatType));
        (yyval.ExprType) = new Constant(se);
    }
#line 1897 "src/parser.cpp"
    break;

  case 41:
#line 268 "src/parser.y"
                  {(yyval.ExprType) = (yyvsp[0].ExprType);}
#line 1903 "src/parser.cpp"
    break;

  case 42:
#line 269 "src/parser.y"
                                      {
        globals->installSysFunc((yyvsp[-2].StrType));
        SymbolEntry* se = identifiers->lookup((yyvsp[-2].StrType));
        if(se == nullptr) {
            printTyCk("Fun: "  << (char*)(yyvsp[-2].StrType) <<" is not defined.");
        } 
        (yyval.ExprType) = new CallExpr(se);
    }
#line 1916 "src/parser.cpp"
    break;

  case 43:
#line 277 "src/parser.y"
                                                    {
        globals->installSysFunc((yyvsp[-3].StrType));
        SymbolEntry* se = identifiers->lookup((yyvsp[-3].StrType));
        if(se == nullptr) {
            printTyCk("Fun: "  << (char*)(yyvsp[-3].StrType) <<" is not defined.");
        }
        (yyval.ExprType) = new CallExpr(se, (yyvsp[-1].ExprType));
    }
#line 1929 "src/parser.cpp"
    break;

  case 44:
#line 285 "src/parser.y"
                                   {
        SymbolEntry* se = identifiers->lookup((yyvsp[-3].StrType));
        if(se == nullptr) {
            printTyCk("Fun: "  << (char*)(yyvsp[-3].StrType) <<" is not defined.");
        }
        (yyval.ExprType) = new CallExpr(se, (yyvsp[-1].ExprType));
    }
#line 1941 "src/parser.cpp"
    break;

  case 45:
#line 292 "src/parser.y"
                       {
        SymbolEntry* se = identifiers->lookup((yyvsp[-2].StrType));
        if(se == nullptr){
            printTyCk("Fun: " << (char*)(yyvsp[-2].StrType) <<" is not defined.");
        }
        (yyval.ExprType) = new CallExpr(se);
    }
#line 1953 "src/parser.cpp"
    break;

  case 46:
#line 299 "src/parser.y"
                    {
        (yyval.ExprType) = (yyvsp[0].ExprType);
    }
#line 1961 "src/parser.cpp"
    break;

  case 47:
#line 302 "src/parser.y"
                    {
        Type* exprType = (yyvsp[0].ExprType)->getType();
        if((yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *se = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs = new ConstantSymbolEntry(exprType,-se->getValue());
            (yyval.ExprType) = new UnaryExpr(cs, UnaryExpr::SUB, (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(exprType, SymbolTable::getLabel());
            (yyval.ExprType) = new UnaryExpr(se, UnaryExpr::SUB, (yyvsp[0].ExprType));
        }
    }
#line 1977 "src/parser.cpp"
    break;

  case 48:
#line 313 "src/parser.y"
                    {
        if((yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *se = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs = new ConstantSymbolEntry(TypeSystem::boolType,!se->getValue());
            (yyval.ExprType) = new UnaryExpr(cs, UnaryExpr::NOT, (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel());
            (yyval.ExprType) = new UnaryExpr(se, UnaryExpr::NOT, (yyvsp[0].ExprType));
        }
    }
#line 1992 "src/parser.cpp"
    break;

  case 49:
#line 325 "src/parser.y"
                {(yyval.ExprType) = (yyvsp[0].ExprType);}
#line 1998 "src/parser.cpp"
    break;

  case 50:
#line 326 "src/parser.y"
                            {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()&&(yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            if(ts1->getType()->isFloat() || ts2->getType()->isFloat()){
                cs = new ConstantSymbolEntry(TypeSystem::floatType,ts1->getValue()*ts2->getValue());
            }
            else{
                cs = new ConstantSymbolEntry(TypeSystem::intType,(int)ts1->getValue()*(int)ts2->getValue());
            }
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::MUL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        } else{
            if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()
                && dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry())->getValue() == 0){
                ConstantSymbolEntry *cs = new ConstantSymbolEntry((yyvsp[0].ExprType)->getType(), 0);
                (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::MUL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
            } 
            else if((yyvsp[0].ExprType)->getSymbolEntry()->isConstant() 
                && dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry())->getValue() == 0){
                ConstantSymbolEntry *cs = new ConstantSymbolEntry((yyvsp[-2].ExprType)->getType(), 0);
                (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::MUL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
            } 
            else{
                SymbolEntry* se;
                if ((yyvsp[-2].ExprType)->getType()->isFloat() || (yyvsp[0].ExprType)->getType()->isFloat()) {
                    se = new TemporarySymbolEntry(TypeSystem::floatType, SymbolTable::getLabel());
                    (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::MUL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
                } else {
                    se = new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel());
                    (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::MUL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
                }
            }
        }
    }
#line 2038 "src/parser.cpp"
    break;

  case 51:
#line 361 "src/parser.y"
                            {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()&&(yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            if(ts1->getType()->isFloat() || ts2->getType()->isFloat()){
                cs = new ConstantSymbolEntry(TypeSystem::floatType,ts1->getValue()/ts2->getValue());
            }
            else{
                cs = new ConstantSymbolEntry(TypeSystem::intType,(int)ts1->getValue()/(int)ts2->getValue());
            }
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::DIV, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()
                && dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry())->getValue() == 0){
                ConstantSymbolEntry *cs = new ConstantSymbolEntry((yyvsp[0].ExprType)->getType(), 0);
                (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::DIV, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
            } 
            else{
                SymbolEntry* se;
                if ((yyvsp[-2].ExprType)->getType()->isFloat() || (yyvsp[0].ExprType)->getType()->isFloat()) {
                    se = new TemporarySymbolEntry(TypeSystem::floatType, SymbolTable::getLabel());
                    (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::DIV, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
                } else {
                    se = new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel());
                    (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::DIV, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
                }
            }
        }
    }
#line 2073 "src/parser.cpp"
    break;

  case 52:
#line 391 "src/parser.y"
                            {
        if ((yyvsp[-2].ExprType)->getType()->isFloat() || (yyvsp[0].ExprType)->getType()->isFloat()) {
            printTyCk("Wrong! Mod needs integer operands!");
        }
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()&&(yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs =new ConstantSymbolEntry(TypeSystem::intType,(int)ts1->getValue() % (int)ts2->getValue());
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::MOD, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()
                && dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry())->getValue() == 0){
                ConstantSymbolEntry *cs = new ConstantSymbolEntry((yyvsp[0].ExprType)->getType(), 0);
                (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::MOD, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
            } 
            else{
                SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel());
                (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::MOD, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
            }
        }
    }
#line 2099 "src/parser.cpp"
    break;

  case 53:
#line 414 "src/parser.y"
              {(yyval.ExprType) = (yyvsp[0].ExprType);}
#line 2105 "src/parser.cpp"
    break;

  case 54:
#line 415 "src/parser.y"
                          {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()&&(yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            if(ts1->getType()->isFloat() || ts2->getType()->isFloat()){
                cs = new ConstantSymbolEntry(TypeSystem::floatType,ts1->getValue() + ts2->getValue());
            }
            else{
                cs = new ConstantSymbolEntry(TypeSystem::intType,(int)ts1->getValue() + (int)ts2->getValue());
            }
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::ADD, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se;
            if ((yyvsp[-2].ExprType)->getType()->isFloat() || (yyvsp[0].ExprType)->getType()->isFloat()) {
                se = new TemporarySymbolEntry(TypeSystem::floatType, SymbolTable::getLabel());
                (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::ADD, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
            } else {
                se = new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel());
                (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::ADD, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
            }
        }
    }
#line 2133 "src/parser.cpp"
    break;

  case 55:
#line 438 "src/parser.y"
                          {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant() && (yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            if(ts1->getType()->isFloat() || ts2->getType()->isFloat()){
                cs = new ConstantSymbolEntry(TypeSystem::floatType,ts1->getValue() - ts2->getValue());
            }
            else{
                cs = new ConstantSymbolEntry(TypeSystem::intType,(int)ts1->getValue() - (int)ts2->getValue());
            }
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::SUB, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se;
            if ((yyvsp[-2].ExprType)->getType()->isFloat() || (yyvsp[0].ExprType)->getType()->isFloat()) {
                se = new TemporarySymbolEntry(TypeSystem::floatType, SymbolTable::getLabel());
                (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::SUB, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
            } else {
                se = new TemporarySymbolEntry(TypeSystem::intType, SymbolTable::getLabel());
                (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::SUB, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
            }
        }
    }
#line 2161 "src/parser.cpp"
    break;

  case 56:
#line 463 "src/parser.y"
              {
        (yyval.ExprType) = (yyvsp[0].ExprType);
    }
#line 2169 "src/parser.cpp"
    break;

  case 57:
#line 466 "src/parser.y"
                           {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant() && (yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            cs = new ConstantSymbolEntry(TypeSystem::boolType,ts1->getValue() < ts2->getValue());
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::LESS, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel());
            (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::LESS, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }
    }
#line 2186 "src/parser.cpp"
    break;

  case 58:
#line 478 "src/parser.y"
                                {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()&&(yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            cs = new ConstantSymbolEntry(TypeSystem::boolType,ts1->getValue() <= ts2->getValue());
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::LESSEQUAL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel());
            (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::LESSEQUAL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }
    }
#line 2203 "src/parser.cpp"
    break;

  case 59:
#line 490 "src/parser.y"
                              {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()&&(yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            cs = new ConstantSymbolEntry(TypeSystem::boolType,ts1->getValue() > ts2->getValue());
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::GREATER, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel());
            (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::GREATER, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }
    }
#line 2220 "src/parser.cpp"
    break;

  case 60:
#line 502 "src/parser.y"
                                   {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant()&&(yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            cs = new ConstantSymbolEntry(TypeSystem::boolType,ts1->getValue() >= ts2->getValue());
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::GREATEREQUAL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel());
            (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::GREATEREQUAL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }
    }
#line 2237 "src/parser.cpp"
    break;

  case 61:
#line 516 "src/parser.y"
              {(yyval.ExprType) = (yyvsp[0].ExprType);}
#line 2243 "src/parser.cpp"
    break;

  case 62:
#line 517 "src/parser.y"
                           {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant() && (yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            cs = new ConstantSymbolEntry(TypeSystem::boolType,ts1->getValue() == ts2->getValue());
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::EQUAL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel());
            (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::EQUAL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }
    }
#line 2260 "src/parser.cpp"
    break;

  case 63:
#line 529 "src/parser.y"
                              {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant() && (yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            cs = new ConstantSymbolEntry(TypeSystem::boolType,ts1->getValue() != ts2->getValue());
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::NOTEQUAL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel());
            (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::NOTEQUAL, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }
    }
#line 2277 "src/parser.cpp"
    break;

  case 64:
#line 543 "src/parser.y"
             {(yyval.ExprType) = (yyvsp[0].ExprType);}
#line 2283 "src/parser.cpp"
    break;

  case 65:
#line 544 "src/parser.y"
                          {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant() && (yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            cs = new ConstantSymbolEntry(TypeSystem::boolType,ts1->getValue() && ts2->getValue());
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::AND, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel());
            (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::AND, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }
    }
#line 2300 "src/parser.cpp"
    break;

  case 66:
#line 558 "src/parser.y"
               {(yyval.ExprType) = (yyvsp[0].ExprType);}
#line 2306 "src/parser.cpp"
    break;

  case 67:
#line 559 "src/parser.y"
                          {
        if((yyvsp[-2].ExprType)->getSymbolEntry()->isConstant() && (yyvsp[0].ExprType)->getSymbolEntry()->isConstant()){
            ConstantSymbolEntry *ts1 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[-2].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *ts2 = dynamic_cast<ConstantSymbolEntry*>((yyvsp[0].ExprType)->getSymbolEntry());
            ConstantSymbolEntry *cs;
            cs = new ConstantSymbolEntry(TypeSystem::boolType,ts1->getValue() || ts2->getValue());
            (yyval.ExprType) = new BinaryExpr(cs, BinaryExpr::OR, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }else{
            SymbolEntry* se = new TemporarySymbolEntry(TypeSystem::boolType, SymbolTable::getLabel());
            (yyval.ExprType) = new BinaryExpr(se, BinaryExpr::OR, (yyvsp[-2].ExprType), (yyvsp[0].ExprType));
        }
    }
#line 2323 "src/parser.cpp"
    break;

  case 68:
#line 573 "src/parser.y"
              {(yyval.ExprType) = (yyvsp[0].ExprType);}
#line 2329 "src/parser.cpp"
    break;

  case 69:
#line 577 "src/parser.y"
          {
        (yyval.type) = TypeSystem::intType;
        CurType = TypeSystem::intType;
    }
#line 2338 "src/parser.cpp"
    break;

  case 70:
#line 581 "src/parser.y"
           {
        (yyval.type) = TypeSystem::voidType;
    }
#line 2346 "src/parser.cpp"
    break;

  case 71:
#line 584 "src/parser.y"
            {
        *fcheck=1;
        (yyval.type) = TypeSystem::floatType;
        CurType = TypeSystem::floatType;
    }
#line 2356 "src/parser.cpp"
    break;

  case 72:
#line 592 "src/parser.y"
                   {(yyval.StateType) = (yyvsp[0].StateType);}
#line 2362 "src/parser.cpp"
    break;

  case 73:
#line 593 "src/parser.y"
                        {(yyval.StateType) = (yyvsp[0].StateType);}
#line 2368 "src/parser.cpp"
    break;

  case 74:
#line 597 "src/parser.y"
                                 {
        if ((yyvsp[-2].type)->isFloat()) {
            *fcheck=1;
        }
        (yyval.StateType) = (yyvsp[-1].StateType);
    }
#line 2379 "src/parser.cpp"
    break;

  case 75:
#line 606 "src/parser.y"
                                {
        (yyval.StateType) = (yyvsp[-2].StateType);
        (yyvsp[-2].StateType)->setNext((yyvsp[0].StateType));
    }
#line 2388 "src/parser.cpp"
    break;

  case 76:
#line 610 "src/parser.y"
              {(yyval.StateType) = (yyvsp[0].StateType);}
#line 2394 "src/parser.cpp"
    break;

  case 77:
#line 614 "src/parser.y"
         {
        SymbolEntry* se = new IdentifierSymbolEntry(CurType, (yyvsp[0].StrType), identifiers->getLevel());
        if(!identifiers->install((yyvsp[0].StrType), se)) {
            printTyCk("identifier " << (char*)(yyvsp[0].StrType) <<" is already defined.");
        }
        (yyval.StateType) = new DeclStmt(new Id(se));
        delete [](yyvsp[0].StrType);
    }
#line 2407 "src/parser.cpp"
    break;

  case 78:
#line 622 "src/parser.y"
                        {
        SymbolEntry* se = new IdentifierSymbolEntry(CurType, (yyvsp[0].StrType), identifiers->getLevel());
        if(!identifiers->install((yyvsp[0].StrType), se)) {
            printTyCk("identifier " << (char*)(yyvsp[0].StrType) <<" is already defined.");
        }
        (yyval.StateType) = new DeclStmt(new Id(se));
        delete [](yyvsp[0].StrType);
    }
#line 2420 "src/parser.cpp"
    break;

  case 79:
#line 630 "src/parser.y"
                          {
        SymbolEntry* se = new IdentifierSymbolEntry(CurType, (yyvsp[0].StrType), identifiers->getLevel());
        if(!identifiers->install((yyvsp[0].StrType), se)) {
            printTyCk("identifier " << (char*)(yyvsp[0].StrType) <<" is already defined.");
        }
        (yyval.StateType) = new DeclStmt(new Id(se));
        delete [](yyvsp[0].StrType);
    }
#line 2433 "src/parser.cpp"
    break;

  case 80:
#line 638 "src/parser.y"
                            {
        IdentifierSymbolEntry* se = new IdentifierSymbolEntry(CurType, (yyvsp[-2].StrType), identifiers->getLevel());
        if(isConst){
            se->setConst();
        }
        if(!identifiers->install((yyvsp[-2].StrType), se)) {
            printTyCk("Identifier " << (char*)(yyvsp[-2].StrType) << " is already defined.");
        }
        double val = (yyvsp[0].ExprType)->getValue();
        if (CurType->isInt() && (yyvsp[0].ExprType)->getType()->isFloat()) {
            // float temp = (float)val;
            // int temp1 = (int)temp;
            // val = (double)temp1;
            val = (int)val;
        }
        se->setValue(val);
        (yyval.StateType) = new DeclStmt(new Id(se), (yyvsp[0].ExprType));
        delete [](yyvsp[-2].StrType);
    }
#line 2457 "src/parser.cpp"
    break;

  case 81:
#line 657 "src/parser.y"
                                           {
        IdentifierSymbolEntry* se = new IdentifierSymbolEntry(CurType, (yyvsp[-2].StrType), identifiers->getLevel());
        if(isConst){
            se->setConst();
        }
        if(!identifiers->install((yyvsp[-2].StrType), se)) {
            printTyCk("Identifier " << (char*)(yyvsp[-2].StrType) << " is already defined.");
        }
        double val = (yyvsp[0].ExprType)->getValue();
        if (CurType->isInt() && (yyvsp[0].ExprType)->getType()->isFloat()) {
            // float temp = (float)val;
            // int temp1 = (int)temp;
            // val = (double)temp1;
            val = (int)val;
        }
        se->setValue(val);
        (yyval.StateType) = new DeclStmt(new Id(se), (yyvsp[0].ExprType));
        delete [](yyvsp[-2].StrType);
    }
#line 2481 "src/parser.cpp"
    break;

  case 82:
#line 676 "src/parser.y"
                                             {
        IdentifierSymbolEntry* se = new IdentifierSymbolEntry(CurType, (yyvsp[-2].StrType), identifiers->getLevel());
        if(isConst){
            se->setConst();
        }
        if(!identifiers->install((yyvsp[-2].StrType), se)) {
            printTyCk("Identifier " << (char*)(yyvsp[-2].StrType) << " is already defined.");
        }
        double val = (yyvsp[0].ExprType)->getValue();
        if (CurType->isInt() && (yyvsp[0].ExprType)->getType()->isFloat()) {
            // float temp = (float)val;
            // int temp1 = (int)temp;
            // val = (double)temp1;
            val = (int)val;
        }
        se->setValue(val);
        (yyval.StateType) = new DeclStmt(new Id(se), (yyvsp[0].ExprType));
        delete [](yyvsp[-2].StrType);
    }
#line 2505 "src/parser.cpp"
    break;

  case 83:
#line 695 "src/parser.y"
                      {
        std::vector<int> arrayDims;
        ExprNode* dimNode = (yyvsp[0].ExprType);
        while(dimNode){
            arrayDims.push_back(dimNode->getValue());
            dimNode = dynamic_cast<ExprNode*>(dimNode->getNext());
        }
        Type *type = CurType;
        Type* topType;
        while(!arrayDims.empty()){
            topType = new ArrayType(type, arrayDims.back());
            if(type->isArray())
                (dynamic_cast<ArrayType*>(type))->setArrayType(topType);
            type = topType;
            arrayDims.pop_back();
        }
        curArrayType = dynamic_cast<ArrayType*>(type);
        IdentifierSymbolEntry* se = new IdentifierSymbolEntry(type, (yyvsp[-1].StrType), identifiers->getLevel());
        if(!identifiers->install((yyvsp[-1].StrType), se)) {
            printTyCk("Identifier " << (char*)(yyvsp[-1].StrType) << " is already defined.");
        }
        se->setAllZero();
        (yyval.StateType) = new DeclStmt(new Id(se));
        delete [](yyvsp[-1].StrType);
    }
#line 2535 "src/parser.cpp"
    break;

  case 84:
#line 720 "src/parser.y"
                             {
        std::vector<int> arrayDims;
        ExprNode* dimNode = (yyvsp[-1].ExprType);
        while(dimNode){
            arrayDims.push_back(dimNode->getValue());
            dimNode = dynamic_cast<ExprNode*>(dimNode->getNext());
        }
        Type* type = CurType;
        Type* topType;
        for(auto it = arrayDims.rbegin(); it != arrayDims.rend(); it++) {
            topType = new ArrayType(type, *it);
            if(type->isArray())
                (dynamic_cast<ArrayType*>(type))->setArrayType(topType);
            type = topType;
        }
        curArrayType = dynamic_cast<ArrayType*>(type);
        idx = 0;
        InitValuesVec.clear();
        SymbolEntry* se = new IdentifierSymbolEntry(type, (yyvsp[-2].StrType), identifiers->getLevel());
        if(isConst)
            (dynamic_cast<IdentifierSymbolEntry*>(se))->setConst();
        (yyval.se) = se;
        arrayValue = new double[curArrayType->getSize()];
        NoZeroNum = 0;
    }
#line 2565 "src/parser.cpp"
    break;

  case 85:
#line 745 "src/parser.y"
                  {
        IdentifierSymbolEntry* identSe = dynamic_cast<IdentifierSymbolEntry*>((yyvsp[-1].se));
        identSe->setArrayValue(arrayValue);
        identSe->setNotZeroNum(NoZeroNum);
        if ((NoZeroNum == 0) || (dynamic_cast<InitValueListExpr*>((yyvsp[0].ExprType)))->isEmpty()){
            identSe->setAllZero();
            (dynamic_cast<InitValueListExpr*>((yyvsp[0].ExprType)))->setAllZero();
        }
        if (!identifiers->install((yyvsp[-4].StrType), identSe)) {
            printTyCk("Identifier " << (char*)(yyvsp[-4].StrType) << " is already defined.");
        }
        (yyval.StateType) = new DeclStmt(new Id((yyvsp[-1].se)), (yyvsp[0].ExprType));
        delete [](yyvsp[-4].StrType);
    }
#line 2584 "src/parser.cpp"
    break;

  case 86:
#line 762 "src/parser.y"
                                       {
        if ((yyvsp[-2].type)->isFloat()) {
            *fcheck=1;
        }
        isConst = true;
        (yyval.StateType) = (yyvsp[-1].StateType);
        isConst = false;
    }
#line 2597 "src/parser.cpp"
    break;

  case 87:
#line 774 "src/parser.y"
                      {
        (yyval.ExprType) = new ExprNode(nullptr);
    }
#line 2605 "src/parser.cpp"
    break;

  case 88:
#line 777 "src/parser.y"
                             {
        (yyval.ExprType) = (yyvsp[-1].ExprType);
    }
#line 2613 "src/parser.cpp"
    break;

  case 89:
#line 780 "src/parser.y"
                                          {
        (yyval.ExprType) = (yyvsp[-3].ExprType);
        (yyvsp[-3].ExprType)->setNext((yyvsp[-1].ExprType));
    }
#line 2622 "src/parser.cpp"
    break;

  case 90:
#line 786 "src/parser.y"
           {
        if (!(yyvsp[0].ExprType)->getType()->isInt() && !(yyvsp[0].ExprType)->getType()->isFloat()) {
            printTyCk("rval is invalid.");
        }
        (yyval.ExprType) = (yyvsp[0].ExprType);
        if (!InitValuesVec.empty()) {
            double val = (yyvsp[0].ExprType)->getValue();
            if (val)
                NoZeroNum++;
            if (CurType->isInt() && (yyvsp[0].ExprType)->getType()->isFloat()) {
                // float temp = (float)val;
                // int temp1 = (int)temp;
                // arrayValue[idx++] = (double)temp1;
                arrayValue[idx++] = (int)val;
            } else {
                arrayValue[idx++] = val;
            }

            Type* topType = InitValuesVec.back()->getSymbolEntry()->getType();
            if (topType == TypeSystem::intType || topType == TypeSystem::floatType) {
                if ((topType->isInt() && (yyvsp[0].ExprType)->getType()->isFloat()) ||
                    (topType->isFloat() && (yyvsp[0].ExprType)->getType()->isInt())) {
                    ImplicitCastExpr* temp = new ImplicitCastExpr((yyvsp[0].ExprType), CurType);
                    InitValuesVec.back()->addExpr(temp);
                } else {
                    InitValuesVec.back()->addExpr((yyvsp[0].ExprType));
                }
            } else {
                while (topType) {
                    if (((dynamic_cast<ArrayType*>(topType)))->getElementType() != TypeSystem::intType &&
                        ((dynamic_cast<ArrayType*>(topType)))->getElementType() != TypeSystem::floatType) {
                        topType = ((dynamic_cast<ArrayType*>(topType)))->getElementType();
                        SymbolEntry* se = new ConstantSymbolEntry(topType);
                        InitValueListExpr* list = new InitValueListExpr(se);
                        InitValuesVec.back()->addExpr(list);
                        InitValuesVec.push_back(list);
                    } else {
                        Type* elemType = ((dynamic_cast<ArrayType*>(topType)))->getElementType();
                        if ((elemType->isInt() && (yyvsp[0].ExprType)->getType()->isFloat()) ||
                            (elemType->isFloat() && (yyvsp[0].ExprType)->getType()->isInt())) {
                            ImplicitCastExpr* temp = new ImplicitCastExpr((yyvsp[0].ExprType), elemType);
                            InitValuesVec.back()->addExpr(temp);
                        } else {
                            InitValuesVec.back()->addExpr((yyvsp[0].ExprType));
                        }
                        while (InitValuesVec.back()->isFull() && InitValuesVec.size() != (long unsigned int)leftCnt) {
                            topType = ((ArrayType*)topType)->getArrayType();
                            InitValuesVec.pop_back();
                        }
                        break;
                    }
                }
            }
        }         
    }
#line 2682 "src/parser.cpp"
    break;

  case 91:
#line 841 "src/parser.y"
                    {
        SymbolEntry* se;
        ExprNode* list;
        if(InitValuesVec.empty()){
            memset(arrayValue, 0, curArrayType->getSize());
            idx += curArrayType->getSize() / CurType->getSize();
            se = new ConstantSymbolEntry(curArrayType);
            list = new InitValueListExpr(se);
        }else{
            Type* type = (dynamic_cast<ArrayType*>(InitValuesVec.back()->getSymbolEntry()->getType()))->getElementType();
            int len = type->getSize() / CurType->getSize();
            memset(arrayValue + idx, 0, type->getSize());
            idx += len;
            se = new ConstantSymbolEntry(type);
            list = new InitValueListExpr(se);
            InitValuesVec.back()->addExpr(list);
            while(InitValuesVec.back()->isFull() && InitValuesVec.size() != (long unsigned int)leftCnt){
                InitValuesVec.pop_back();
            }
        }
        (yyval.ExprType) = list;
    }
#line 2709 "src/parser.cpp"
    break;

  case 92:
#line 863 "src/parser.y"
             {
        SymbolEntry* se;
        if(!InitValuesVec.empty())
            curArrayType = dynamic_cast<ArrayType*>((dynamic_cast<ArrayType*>(InitValuesVec.back()->getSymbolEntry()->getType()))->getElementType());
        se = new ConstantSymbolEntry(curArrayType);
        if (curArrayType->getElementType() != TypeSystem::intType &&
            curArrayType->getElementType() != TypeSystem::floatType) {
            curArrayType = dynamic_cast<ArrayType*>(curArrayType->getElementType());
        }
        InitValueListExpr* expr = new InitValueListExpr(se);
        if(!InitValuesVec.empty())
            InitValuesVec.back()->addExpr(expr);
        InitValuesVec.push_back(expr);
        (yyval.ExprType) = expr;
        leftCnt++;
    }
#line 2730 "src/parser.cpp"
    break;

  case 93:
#line 879 "src/parser.y"
                     {
        leftCnt--;
        while (InitValuesVec.back() != (yyvsp[-2].ExprType) && InitValuesVec.size() > (long unsigned int)(leftCnt + 1))
            InitValuesVec.pop_back();
        if (InitValuesVec.back() == (yyvsp[-2].ExprType))
            InitValuesVec.pop_back();
        (yyval.ExprType) = (yyvsp[-2].ExprType);
        if (!InitValuesVec.empty())
            while (InitValuesVec.back()->isFull() && InitValuesVec.size() != (long unsigned int)leftCnt) {
                InitValuesVec.pop_back();
            }
        int size = (dynamic_cast<ArrayType*>((yyval.ExprType)->getSymbolEntry()->getType()))->getSize() / CurType->getSize();
        while (idx % size != 0)
            arrayValue[idx++] = 0;
        if (!InitValuesVec.empty())
            curArrayType = dynamic_cast<ArrayType*>(
                (dynamic_cast<ArrayType*>(InitValuesVec.back()->getSymbolEntry()->getType()))->getElementType());
    }
#line 2753 "src/parser.cpp"
    break;

  case 94:
#line 900 "src/parser.y"
                  {
        (yyval.ExprType) = (yyvsp[0].ExprType);
    }
#line 2761 "src/parser.cpp"
    break;

  case 95:
#line 903 "src/parser.y"
                                {
        (yyval.ExprType) = (yyvsp[-2].ExprType);
    }
#line 2769 "src/parser.cpp"
    break;

  case 96:
#line 910 "src/parser.y"
            {
        identifiers = new SymbolTable(identifiers);
        if ((yyvsp[-1].type)->isFloat()) *fcheck=1;
        IntParamNum = 0;
        FloatParamNum = 0;
        AllParamNum = 0;
        ReturnType = (yyvsp[-1].type);
    }
#line 2782 "src/parser.cpp"
    break;

  case 97:
#line 918 "src/parser.y"
                                  {
        Type* funcType;
        std::vector<Type*> vec;
        std::vector<SymbolEntry*> vec1;
        DeclStmt* temp = dynamic_cast<DeclStmt*>((yyvsp[-1].StateType));
        while (temp) {
            vec.push_back(temp->getId()->getSymbolEntry()->getType());
            vec1.push_back(temp->getId()->getSymbolEntry());
            temp = dynamic_cast<DeclStmt*>(temp->getNext());
        }
        funcType = new FunctionType((yyvsp[-5].type), vec, vec1);
        SymbolEntry* se = new IdentifierSymbolEntry(
            funcType, (yyvsp[-4].StrType), identifiers->getPrev()->getLevel());
        (dynamic_cast<IdentifierSymbolEntry*>(se))->setIntParamNo(IntParamNum);
        (dynamic_cast<IdentifierSymbolEntry*>(se))->setFloatParamNo(FloatParamNum);
        if (!identifiers->getPrev()->install((yyvsp[-4].StrType), se)) {
            printTyCk("redefinition of " << (yyvsp[-4].StrType) << " " << se->getType()->toStr().c_str());
        }
        (yyval.se) = se; 
    }
#line 2807 "src/parser.cpp"
    break;

  case 98:
#line 938 "src/parser.y"
               {
        (yyval.StateType) = new FunctionDef((yyvsp[-1].se), dynamic_cast<DeclStmt*>((yyvsp[-3].StateType)), (yyvsp[0].StateType));
        SymbolTable* top = identifiers;
        identifiers = identifiers->getPrev();
        delete top;
        delete [](yyvsp[-6].StrType);
    }
#line 2819 "src/parser.cpp"
    break;

  case 99:
#line 947 "src/parser.y"
           {(yyval.ExprType) = (yyvsp[0].ExprType);}
#line 2825 "src/parser.cpp"
    break;

  case 100:
#line 948 "src/parser.y"
                             {
        (yyval.ExprType) = (yyvsp[-2].ExprType);
        (yyval.ExprType)->setNext((yyvsp[0].ExprType));
    }
#line 2834 "src/parser.cpp"
    break;

  case 101:
#line 953 "src/parser.y"
                  {(yyval.StateType) = (yyvsp[0].StateType);}
#line 2840 "src/parser.cpp"
    break;

  case 102:
#line 954 "src/parser.y"
             {(yyval.StateType) = nullptr;}
#line 2846 "src/parser.cpp"
    break;

  case 103:
#line 956 "src/parser.y"
                                   {
        (yyval.StateType) = (yyvsp[-2].StateType);
        (yyval.StateType)->setNext((yyvsp[0].StateType));
    }
#line 2855 "src/parser.cpp"
    break;

  case 104:
#line 960 "src/parser.y"
                 {
        (yyval.StateType) = (yyvsp[0].StateType);
    }
#line 2863 "src/parser.cpp"
    break;

  case 105:
#line 965 "src/parser.y"
              {
        SymbolEntry* se;
        if ((yyvsp[-1].type)->isFloat()) {
            *fcheck=1;
            se = new IdentifierSymbolEntry((yyvsp[-1].type), (yyvsp[0].StrType), identifiers->getLevel(), FloatParamNum++);
            (dynamic_cast<IdentifierSymbolEntry*>(se))->setAllParamNo(FloatParamNum + IntParamNum - 1);
            if (FloatParamNum > 4){
                (dynamic_cast<IdentifierSymbolEntry*>(se))->setStackParamNo(AllParamNum);
                AllParamNum++;
            }
        } else {
            se = new IdentifierSymbolEntry((yyvsp[-1].type), (yyvsp[0].StrType), identifiers->getLevel(), IntParamNum++);
            (dynamic_cast<IdentifierSymbolEntry*>(se))->setAllParamNo(FloatParamNum + IntParamNum - 1);
            if (IntParamNum > 4){
                (dynamic_cast<IdentifierSymbolEntry*>(se))->setStackParamNo(AllParamNum);
                AllParamNum++;
            }
        }
        identifiers->install((yyvsp[0].StrType), se);
        (dynamic_cast<IdentifierSymbolEntry*>(se))->setLabel();
        (dynamic_cast<IdentifierSymbolEntry*>(se))->setAddr(new Operand(se));
        (yyval.StateType) = new DeclStmt(new Id(se));
        delete [](yyvsp[0].StrType);
    }
#line 2892 "src/parser.cpp"
    break;

  case 106:
#line 989 "src/parser.y"
                           {
        if ((yyvsp[-2].type)->isFloat()) *fcheck=1;
            
        ExprNode* temp = (yyvsp[0].ExprType);
        Type* arr = (yyvsp[-2].type);
        Type* arr1;
        std::vector<ExprNode*> InitValuesVec;
        while (temp) {
            InitValuesVec.push_back(temp);
            temp = dynamic_cast<ExprNode*>(temp->getNext());
        }
        while (!InitValuesVec.empty()) {
            arr1 = new ArrayType(arr, InitValuesVec.back()->getValue());
            if (arr->isArray())
                (dynamic_cast<ArrayType*>(arr))->setArrayType(arr1);
            arr = arr1;
            InitValuesVec.pop_back();
        }
        SymbolEntry* se = new IdentifierSymbolEntry(arr, (yyvsp[-1].StrType), identifiers->getLevel(), IntParamNum++);
        (dynamic_cast<IdentifierSymbolEntry*>(se))->setAllParamNo(FloatParamNum + IntParamNum - 1);
        if (IntParamNum > 4){
            (dynamic_cast<IdentifierSymbolEntry*>(se))->setStackParamNo(AllParamNum);
            AllParamNum++;
        }
        identifiers->install((yyvsp[-1].StrType), se);
        (dynamic_cast<IdentifierSymbolEntry*>(se))->setLabel();
        (dynamic_cast<IdentifierSymbolEntry*>(se))->setAddr(new Operand(se));
        (yyval.StateType) = new DeclStmt(new Id(se));
        delete [](yyvsp[-1].StrType);
    }
#line 2927 "src/parser.cpp"
    break;


#line 2931 "src/parser.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[+*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1020 "src/parser.y"


int yyerror(char const* message)
{
    std::cerr<<message<<std::endl;
    return -1;
}
